%!TEX root=../source.tex
%!TEX file=content/cdpr-simulation-framework.tex

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Multibody Cable Robot Simulation Framework}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{\secname}
  \framesubtitle{Putting Things Together}

  \begin{minipage}[c]{0.49\linewidth}
    Take $\numcable$ \alert{cables} with their dynamics
    %
    \vspace*{-0.25\baselineskip}%
    \begin{align*}
      \Mass_{\subcable_{\cabindex}} \,
      \ddotgenq_{\subcable_{\cabindex}}
      +
      \vect{f}_{\subcable_{\cabindex}, \msinternal}
      +
      \vect{f}_{\subcable_{\cabindex}, \msexternal}
        & = \zeros
    \end{align*}
    
    and one \alert{platform} with $\dof$ degrees of freedom%
    %
    \vspace*{-0.25\baselineskip}%
    \begin{align*}
      \Mass_{\subplatform} \,
      \ddotgenq_{\subplatform}
      +
      \vect{f}_{\subcable_{\cabindex}, \msinternal}
      % \fictitiousforces \of{\genq_{\subplatform}, \dotgenq_{\subplatform}}
      +
      \vect{f}_{\subcable_{\cabindex}, \msexternal}
      % + \wrench
        & = \zeros
    \end{align*}
    
    Constrain cable ends to%
    %
    \vspace*{-0.25\baselineskip}%
    \begin{align*}
      \text{winch}
        & 
        & \posconstraints_{\subcable_{\cabindex}, \subproximal} \of{ \genq_{\subcable_{\cabindex}}, \genq_{\subplatform}, t }
        & = \curve_{\cabindex} \of{0, t}
            -
            \ai
          = \zeros \,
          \\
      \text{platform}
        &
        & \posconstraints_{\subcable_{\cabindex}, \subdistal} \of{ \genq_{\subcable_{\cabindex}}, \genq_{\subplatform}, t }
        & = \curve_{\cabindex} \of{1, t}
            -
            \parentheses*{
              \platpos_{\subplatform}
              +
              \platrot \,
              \bi
            }
          = \zeros \,
            .
    \end{align*}
    
    % Constrain cable \alert{distal} end to \alert{platform}%
    % %
    % \vspace*{-0.25\baselineskip}%
    % \begin{align*}
    %   \posconstraints_{\subcable_{\cabindex}, \subproximal} \of{ \genq_{\subcable_{\cabindex}}, \genq_{\subplatform}, t }
    %     & = \curve_{\cabindex} \of{1, t}
    %         -
    %         \parentheses*{
    %           \platpos
    %           +
    %           \platrot \,
    %           \bi
    %         }
    %       = \zeros
    % \end{align*}
    
    Yields system of \alert{differential-algebraic equations}%
    %
    \vspace*{-0.25\baselineskip}%
    \begin{align*}
      \Mass_{\subsystem} \,
        \ddotgenq_{\subsystem}
        & = \vect{f}_{\subsystem} \of{\genq_{\subsystem}, \dotgenq_{\subsystem}}
            +
            \transpose{\jacposconstraints} \,
            \vect{\lambda} \,
            ,
            \\
      \zeros
        & = \posconstraints_{\subsystem} \of{ \genq_{\subsystem}, t} \,
            ,
    \end{align*}
  \end{minipage}%
  \hfill%
  \begin{minipage}[c]{0.49\linewidth}
    \begin{figure}
      \centering
      \smaller[2]
      % \tikzexternalenable%
      % \tikzsetnextfilename{caro-dynamics--named--ipanema-mini--statics--shape}
      \includegraphics[%
          width=1.00\linewidth,%
          axisratio=1.00,%
        ]{caro-dynamics/named/ipanema-mini/statics/shape}
      % \tikzexternaldisable%
      \caption{Cable robot \IPAnemaMini kinematically solved with the proposed multibody cable robot simulation framework.}
    \end{figure}
  \end{minipage}%
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% POSSIBLY REMOVE THIS SLIDE IF TIME REQUIRES
\begin{frame}%[REMOVE]
  \frametitle{\secname}
  \framesubtitle{Constraint Violation Handling~\citep{Arnold.2004}}

  \begin{minipage}[t]{0.49\linewidth}%
    % \vspace*{-0.25\baselineskip}%
    General multibody system dynamics:%
    %
    \begin{align*}
      \Mass \,
        \ddotgenq
        & = \vect{f} \of{\genq, \dotgenq, t}
            +
            \transpose{\jacposconstraints} \,
            \vect{\lambda} \,
            ,
            \\
      \zeros
        & = \posconstraints \of{ \genq, t} \,
            ,
    \end{align*}
    
    \alert{Hidden constraints:}
    %
    % \vspace*{-0.25\baselineskip}%
    \begin{align*}
      \od{
        \posconstraints
      }{
        t
      }
        & = \pd{
              \posconstraints
            }{
              \genq
            } \,
            \dotgenq
            +
            \pd{
              \posconstraints
            }{
              t
            }
          = \jacposconstraints \,
            \dotgenq
            +
            \jacobian[t]{\posconstraints}
          \equiv \zeros \,
            ,
        \\  
      \od[2]{
        \posconstraints
      }{
        t
      }
        & = \jacobian*{
              \jacposconstraints \,
              \dotgenq
            } \,
            \dotgenq
            +
            \jacposconstraints \,
            \ddotgenq
            +
            \dotsb
            \\
        & \phantom{=}
            +
            2 \,
            \jacobian[\genq, t]{
              \posconstraints
            } \,
            \dotgenq
            +
            \jacobian[t][2]{
              \posconstraints
            }
          \equiv \zeros \,
            .
    \end{align*}
    
    Numerical inaccuracies lead to \alert{constraint drift} over time
  \end{minipage}%
  \hfill%
  \begin{minipage}[t]{0.49\linewidth}
    Baumgarte stabilization technique \citep{Baumgarte.1972}
    % Constraint stabilization techniques avoid drift by \alert{additional dynamics} on constraint level%
    %
    \vspace*{-0.25\baselineskip}%
    \begin{align*}
      \begin{bmatrix}
        \Mass \of{\genq, \dotgenq, t}
          & -\transpose{\jacposconstraints} \\
        \jacposconstraints
          & \zeros
      \end{bmatrix}
      \cdot
      \begin{bmatrix}
        \ddotgenq \\
        \posconstraintforces
      \end{bmatrix}
      & = 
        \begin{bmatrix}
          \vect{f} \of{\genq, \dotgenq, t} \\
          \vect{\zeta} \of{\genq, \dotgenq}
            -
            s \of{ \posconstraints, \dot{\posconstraints} }
        \end{bmatrix} \,
      \\
    % \end{align*}
    \intertext{introduces constraint violation dynamics}
    % with Baumgarte stabilization term \citep{Baumgarte.1972}
    % \begin{align*}
      s \of{ \posconstraints, \dot{\posconstraints} }
        & = 2 \,
            \matr{\alpha} \,
            \dotposconstraints
            +
            \pow{
              \matr{\beta}
            } \,
            \posconstraints
    \end{align*}
    
    Conventional procedure to solving DAEs%
    %
    \begin{enumerate}
      \item Rewrite second-order ODE into first-order ODE
      \item Solve equation simultaneously for $\parentheses*{\dotgenq, \ddotgenq, \posconstraintforces}$
      \item Integrate solution over time using variable step-size solvers e.g., Runge-Kutta
    \end{enumerate}
  \end{minipage}
  
  \vfill
  
  \begin{takeawayblock}{}
    Constraint stabilization method influences system dynamics; finding suitable parameters is non-trivial; stiff systems require small adaptive step-sizes
  \end{takeawayblock}
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
  \frametitle{\secname}
  \framesubtitle{Discrete Integrator \citep{Betsch.2006,Gonzalez.1999}}

  \begin{minipage}[t]{0.44\linewidth}
    Mechanical integrator proposed by \citeauthor{Betsch.2006}
    \begin{itemize}
      \item \alert{discretize} system along time yielding finite integration time
      \item \alert{preserves} energies and momentums during integration
    \end{itemize}
    
    \begin{figure}
      \centering
      \smaller[2]
      \includegraphics[%
          % width=\linewidth,%
          height=0.45\textheight,%
          axisratio=1.00,%
        ]{betsch-integration-step}
      \vspace*{-1.00\baselineskip}
      \caption{Discrete integration step of Betsch integrator}
    \end{figure}
    
  \end{minipage}%
  \hfill%
  \begin{minipage}[t]{0.54\linewidth}
    Consider time interval~$T_{\iterindex} = \interval{t_{\iterindex}}{t_{\iterindex + 1}}$ (with~$\parentheses*{ \genq_{\iterindex}, \genv_{\iterindex} }$)%
    %
    \vspace*{-0.25\baselineskip}%
    \begin{align*}
      \genq_{\iterindex + 1} - \genq_{\iterindex}
        & = \stepsize \,
            \genv_{\iterindex + \frac{1}{2}} \,
            ,
        \\
      \Mass \parentheses*{ \genv_{\iterindex + 1} - \genv_{\iterindex} }
        & = - \stepsize \,
            \discretenabla \energypotential \of{\genq_{\iterindex}, \genq_{\iterindex + 1}}
            +
            \stepsize \,
            \transpose{
              \discretenabla \posconstraints \of{\genq_{\iterindex}, \genq_{\iterindex + 1}}
            } \,
            \bar{\posconstraintforces} \,
            ,
          \\
      \zeros
        & = \discretenabla \posconstraints \of{\genq_{\iterindex}, \genq_{\iterindex + 1}} \,
            \genv_{ \iterindex + \frac{1}{2}} \,
            .
    \end{align*}
    
    \vspace*{0.50\baselineskip}
    
    Solve system of \alert{non-linear} equations for unknowns $\parentheses*{ \genq_{\iterindex + 1}, \genv_{\iterindex + 1} }$ in residual form%
    %
    \vspace*{-0.25\baselineskip}%
    \begin{align*}
      % \genv_{\iterindex + 1}
      %   & = \frac{
      %         2
      %       }{
      %         \stepsize
      %       } \,
      %       \parentheses*{
      %         \genq_{\iterindex + 1}
      %         -
      %         \genq_{\iterindex}
      %       }
      %       -
      %       \genv_{\iterindex} \,
      %     ,
        % \\
      % \intertext{yielding residual function in $\genq_{\iterindex + 1}$}
      \zeros
      =
      \residual_{\iterindex}^{\loopindex} \of{ \genq_{\iterindex + 1}^{\loopindex}}
        & = \begin{bmatrix}
              \frac{
                2
              }{
                \stepsize
              } \,
                \Mass \,
                \parentheses*{
                  \genq_{\iterindex + 1}^{\loopindex}
                  -
                  \genq_{\iterindex}
                }
                -
                2 \,
                \Mass \,
                \genv_{\iterindex}
                + \dotsb
                \\
              +
                \discretenabla \energypotential \of{ \genq_{\iterindex}, \genq_{\iterindex + 1}^{\loopindex} }
                +
                \stepsize \,
                \transpose{
                  \discretenabla \posconstraints \of{ \genq_{\iterindex}, \genq_{\iterindex + 1}^{\loopindex} }
                } \,
                \bar{\posconstraintforces}
              \\
              \posconstraints \of{ \genq_{\iterindex + 1}^{\loopindex} } \,
            \end{bmatrix}
          \\
      \shortintertext{with update step}
      \genq_{\iterindex + 1}^{\loopindex + 1}
        & = \genq_{\iterindex + 1}^{\loopindex}
            -
            \jacobian*[%
              \genq_{\iterindex + 1}^{\loopindex}%
            ]{%
              \residual_{\iterindex}^{\loopindex} \of{ \genq_{\iterindex + 1}^{\loopindex}}%
            } \,
            \residual_{\iterindex}^{\loopindex} \of{ \genq_{\iterindex + 1}^{\loopindex}}
      %   \\
      % \zeros
      %   & = \frac{
      %         2
      %       }{
      %         \stepsize
      %       } \,
      %       \Mass \,
      %       \parentheses*{
      %         \genq_{\iterindex + 1}
      %         -
      %         \genq_{\iterindex}
      %       }
      %       -
      %       2 \,
      %       \Mass \,
      %       \genv_{\iterindex}
      %       + \dotsb
      %       \\
      %   & \phantom{=}
      %       +
      %       \discretenabla \energypotential \of{ \genq_{\iterindex}, \genq_{\iterindex + 1} }
      %       +
      %       \stepsize \,
      %       \transpose{
      %         \discretenabla \posconstraints \of{ \genq_{\iterindex}, \genq_{\iterindex + 1} }
      %       } \,
      %       \bar{\posconstraintforces}
      %       ,
      %   \\
      % \zeros
      %   & = \posconstraints \of{ \genq_{\iterindex + 1} } \,
      %       ,
    \end{align*}
    
    \vspace*{0.50\baselineskip}
    
    Employ iterative \alert{root-finding methods}
    % Discrete derivative \cite{Gonzalez.1996}%
    % %
    % \vspace*{-0.25\baselineskip}%
    % \begin{align*}
    %   \discretenabla f \of{ \vect{x}, \vect{y} }
    %     & = \pd{
    %           f \of{ \vect{z} }
    %         }{
    %           \genq
    %         }
    %         -
    %         \frac{
    %           f \of{ \vect{y} }
    %           -
    %           f \of{ \vect{x} }
    %           -
    %           \pd{
    %             f \of{ \vect{z} }
    %           }{
    %             \genq
    %           } \,
    %           \vect{v}
    %         }{
    %           \norm{
    %             \vect{v}
    %           }
    %         } \,
    %         \transpose{
    %           \vect{v}
    %         } \,
    %         ,
    %     \\
    %   \vect{v}
    %     & = \vect{y} - \vect{x} \,
    %       ,
    %     \\
    %   \vect{z}
    %     & = \frac{
    %           1
    %         }{
    %           2
    %         } \,
    %         \parentheses{
    %           \vect{x} + \vect{y}
    %         } \,
    %         .
    %   \end{align*}
  \end{minipage}%
\end{frame}
